const cars = {1: ['car a', 'car b'], 3: ['car c']};

const Car = {
  count: (user) => new Promise((resolve, reject) => 
                       setTimeout(() => resolve(cars[user.userId]), 1000))
};

function findCars(users) {
  return Promise.all(users.map((user) => 
    Car.count({
      userId: user._id
    })
    .then((car) => {
      user.hasCar = !!car;
      return user;
    })
  ))
  .then(console.log);
}

const users = [{_id: 1}, {_id: 2}, {_id: 3}];

findCars(users);;
